zh-scheduler
====
**zh-scheduler** is a component which allows user to show daily events.

## Installation
**1)** First of all, check if you have Private Bower's Registry registered in your **.bowerrc** file.
```
{
    "registry": {
        "search": [
            "http://192.168.122.56:5678/"
        ]
    }
}
```


**2)** Then install via Bower:
```
$ bower install --save zh-scheduler
```


**3)** After installed, you need to link the main component's JavaScript file in your **index.html**:
```
<script src="path_to_bower_components/zh-scheduler/dist/zh-scheduler.js">
```
Or the minified version:
```
<script src="path_to_bower_components/zh-scheduler/dist/zh-scheduler.min.js">
```
Do the same with component's CSS file:
```
<link rel="stylesheet" href="path_to_bower_components/zh-scheduler/dist/zh-scheduler.css"/>
```


**4)** **Zh Interval** already registers itself as a package. The default `baseUrl` registered is:
```
<script type="text/javascript">
    window.templateUrls = [
        {
            package: "zh-scheduler",
            baseUrl: "bower_components/zh-scheduler/dist/templates/"
        }
    ]
</script>
```

So, it considers you have `bower_components` folder in the same path that your `index.html`.

If your `bower_components` is in another folder, you can register your own package path, overwriting the default's one:

```
<script type="text/javascript">
    window.templateUrls = [
        {
            package: "zh-scheduler",
            baseUrl: "path_to_bower_components/zh-scheduler/dist/templates/"
        }
    ]
</script>
```

Be careful: if you already have a `window.templateUrls` registered, just insert the package's information inside of that. **Do not** override with another instance of `window.templateUrls`.

## Using as a Widget in your project
After installed, the component can normally be used in a JSON file:
```
"widgets": [
    {
        "label": "My field"
        "name": "MY_SCHEDULER",
        "template": "zh-scheduler#widget/scheduler.html"
    }
]
```
*Remember: zh-scheduler is the package's name registered in your **index.html** using `window.templateUrls`*

## Properties

### color
This property tells to the component what is the property on dataSource that will define the color applied to the cards with events.
```
widgets: [{
	  "name": "SCHEDULER",
	  "isVisible": true,
	  "template": "zh-scheduler#widget/scheduler.html",
	  "color" "COLOR"
}]  
```

### dateFormat
**Zh Scheduler** uses the format `YYYY-MM-DD` as default. But if your project works with another format (e.g. brazilian format, `DD/MM/YYYY`), you can configure it with `dateFormat` property.
```
widgets: [{
	  "name": "SCHEDULER",
	  "isVisible": true,
	  "template": "zh-scheduler#widget/scheduler.html",
	  "dateFormat" "DD/MM/YYYY"
}] 
```

### dateField
This property indicates which property on dataSource represents the event date. The scheduler's calendar needs this property to bind your dataSource.
```
widgets: [{
	  "name": "SCHEDULER",
	  "isVisible": true,
	  "template": "zh-scheduler#widget/scheduler.html",
	  "dateField" "DAY"
}] 
```

### iconProperty
This property indicates which property on dataSource represents the icon's URL that will appears on calendar.
```
widgets: [{
	  "name": "SCHEDULER",
	  "isVisible": true,
	  "template": "zh-scheduler#widget/scheduler.html",
	  "iconProperty": "ICON"
}]  
```

### noEventsText
This property defines which text appears when there are not events.
```
widgets: [{
    "name": "SCHEDULER",
    "isVisible": true,
    "template": "zh-scheduler#widget/scheduler.html",
    "noEventsText": "No events for today."
}]
```

### type
This property defines how the field will be presented on the card. To the field 
be presented like a title configure this one like:
```
widgets:[{
    "name": "SCHEDULER",
    "isVisible": true,
    "template": "zh-scheduler#widget/scheduler.html",
    "fields": [{
        "name": "Title",
        "type": "title"
    ]}
]}
```

## Functionalities
### Getting currentRows

**Zh Scheduler** has two widgets as children: a calendar and a card (used for events). Each one has its own currentRow. You can access both using the parent widget, the scheduler.

```
schedulerWidget.getCalendarWidget().currentRow
schedulerWidget.getEventsWidget().currentRow
```

## Events
The scheduler component listen to the following events:

* WidgetOnDayClick: when a day is selected
* WidgetOnMonthClick: when a month is selected
* WidgetOnYearClick: when a year is selected
* WidgetOnEventClick: when an event is clicked on events list
* WidgetOnChangeMonth: when a month is changed on calendar's header
* WidgetOnChangeYear: when a year is changed on calendar's header
* WidgetOnChangeDecade: when a decade is changed on calendar's header